/* util.c */

#include <Pilot.h>

#include "pz.h"


/*
 * common routines
 */

VoidPtr GetObjectPtrIn(FormPtr form, Word id)
{
    return FrmGetObjectPtr(form, FrmGetObjectIndex(form, id));
}

VoidPtr GetObjectPtr(Word id)
{
    return GetObjectPtrIn(FrmGetActiveForm(), id);
}

void GetObjectBounds(Word id, RectanglePtr r)
{
    FormPtr form;

    form = FrmGetActiveForm();
    FrmGetObjectBounds(form, FrmGetObjectIndex(form, id), r);
}

void DrawBitmapOver(Word bitmap_id, Word object_id)
{
    VoidHand h;
    BitmapPtr bitmap;
    RectangleType r;

    h = DmGetResource(bitmapRsc, bitmap_id);
    if (h != NULL) {
	bitmap = MemHandleLock(h);
	GetObjectBounds(object_id, &r);
	WinDrawBitmap(bitmap,
		r.topLeft.x + (r.extent.x - bitmap->width) / 2,
		r.topLeft.y + (r.extent.y - bitmap->height) / 2);
	MemHandleUnlock(h);
	DmReleaseResource(h);
    }
}

#ifndef UNPZ
void SetPopup(Word popup_id, Word list_id, Word selection)
{
    ControlPtr popup;
    ListPtr list;

    popup = GetObjectPtr(popup_id);
    list = GetObjectPtr(list_id);

    if (selection < LstGetNumberOfItems(list)) {
	LstSetSelection(list, selection);
	CtlSetLabel(popup, LstGetSelectionText(list, selection));
    } else {
	LstSetSelection(list, noListSelection);
	CtlSetLabel(popup, "???");
    }
}
#endif
